/************************************************************************************
*                                                                                   *
*   File Name   : number_handling.c                                                       *
*   Contents    : ddddd                    *
*   Version     : 1.5                                                               *
*************************************************************************************/ 
#include "number_handling.h"

const byte_t c_ASCII_7SEG_DECODING_TABLE[21] = { 
                                                                {0x30, 0x3F},	/*0*/
                                                                {0x31, 0x06},	/*1*/        
                                                                {0x32, 0x5B},	/*2*/								
                                                                {0x33, 0x4F},	/*3*/
                                                                {0x34, 0x66},	/*4*/					
                                                                {0x35, 0x6D},	/*5*/					
                                                                {0x36, 0x7D},	/*6*/					
                                                                {0x37, 0x07},	/*7*/					
                                                                {0x38, 0xFF},	/*8*/					
                                                                {0x39, 0x6F},	/*9*/
								                                {0x41, 0x77},	/*A*/
								                                {0x53, 0x6D},	/*S*/ 
                                                                {0x42, 0x7C},   /*B*/
                                                                {0x54, 0x70},   /*T*/
                                                                {0x46, 0x71},   /*F*/
                                                                {0x55, 0x3E},   /*U*/
                                                                {0x4C, 0x38},   /*L*/
                                                                {0x43, 0x39},   /*C*/
                                                                {0x48, 0x74},   /*H*/
                                                                {0x52, 0x50},   /*R*/
																{0x5A, 0x00}    /*Z all off*/ 
                                                             };

digits_t f_dt_convert_to_ascii (unsigned int number)
{
digits_t ret_val;
unsigned int highDigit;
if (number > 99)
{
	number = 99;
}
highDigit = (unsigned int)(number / 10);
ret_val.TEN_COUNT_ASC = ((unsigned char)highDigit + 0x30);
ret_val.ONE_COUNT_ASC = ((number - (highDigit*10)) + 0x30);	

return ret_val;
}

unsigned long f_ul_calculate_7seg_codes (unsigned char digit1, unsigned char digit2, unsigned char digit3, unsigned char digit4)
//digits in ASCII-code
{
unsigned long code;
unsigned char digit;
unsigned int  i, j;

for (j=0; j<4; j++)
{
	switch (j)
	{
		case 0:
			digit = digit1;
			break;
		case 1:
			digit = digit2;
			break;
		case 2:
			digit = digit3;
			break;	
		case 3:
			digit = digit4;
			break;
	}
	for (i=0; i<(tableLength); i++)
	{
		if (digit == c_ASCII_7SEG_DECODING_TABLE[i].ASCII)
		{
			code = (code << 8) + c_ASCII_7SEG_DECODING_TABLE[i].SEGMENT;
			i = (tableLength);
		}
	}
}	

return code;
}
